#include "stdafx.h"

#include <string>
#include <map>
#include <cstdio>

#include "BeckyAPI.h"
#include "BkCommon.h"
#include "resource.h"
#include "Util.h"
#include "Logger.h"
#include "AddressInfo.h"
#include "BkBsfilProfile.h"
#include "BkBsfilWrapper.h"
#include "SettingDialog.h"

////////////////////////////////////////////////////////////////////////
// O[oϐ
////////////////////////////////////////////////////////////////////////

#define __DEFINE_GLOBAL_VARIABLES__
#include "DllMain.h"

// ݒ_CAO\\tO
static bool g_whileSetting = false;
// ݒ_CAO\̑M̃zCgXg
static WhiteList g_whiteListSub;

//
// BKC_OnBeforeFilter2()  BKC_FILTER_NEXT gA[ɑ΂ĕ񏈗Kp邽߂
// gtO
//
enum FilterAction {
	FilterFirstStep,
	FilterSecondStep,
};

static FilterAction g_action = FilterFirstStep;

/////////////////////////////////////////////////////////////////////////////
// DLL entry point
/////////////////////////////////////////////////////////////////////////////

BOOL APIENTRY DllMain( HANDLE hModule,
					   DWORD  ul_reason_for_call,
					   LPVOID lpReserved
					 )
{
	g_hInstance = (HINSTANCE)hModule;
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			{
				if (!bka.InitAPI()) {
					return FALSE;
				}

				// Becky! ̃o[W`FbN
				if (!IsValidBeckyVersion(bka.GetVersion())) {
					return FALSE;
				}

				// s
				if (!Initialize()) {
					return FALSE;
				}
			}
			break;
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
		case DLL_PROCESS_DETACH:
			Release();
			break;
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////////////////////
// Callbacks from Becky!
/////////////////////////////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
extern "C"{
#endif

////////////////////////////////////////////////////////////////////////
// Called when the program is started and the main window is created.
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnStart()
{
	/*
	Since BKC_OnStart is called after Becky!'s main window is
	created, at least BKC_OnMenuInit with BKC_MENU_MAIN is called
	before BKC_OnStart. So, do not assume BKC_OnStart is called
	prior to any other callback.
	*/
	// Always return 0.
	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when the main window is closing.
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnExit()
{
	// Return -1 if you don't want to quit.
	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when menu is intialized.
////////////////////////////////////////////////////////////////////////

void AppendBkBsfilMenu(HMENU hMenu, int nPosition, int nType, UINT uResourceID, void (CALLBACK* CmdProc)(HWND, LPARAM), UINT (CALLBACK* CmdUIProc)(HWND, LPARAM))
{
	std::string menuTitle = CResourceManager::FormatResourceString(uResourceID);

	UINT nID = bka.RegisterCommand(menuTitle.c_str(), nType, CmdProc);
	InsertMenu(hMenu, nPosition, MF_BYPOSITION | MF_STRING, nID, menuTitle.c_str());
	if (CmdUIProc) {
		bka.RegisterUICallback(nID, CmdUIProc);
	}
}

int WINAPI BKC_OnMenuInit(HWND hWnd, HMENU hMenu, int nType)
{
	switch (nType) {
	case BKC_MENU_MAIN:
		{
			/* Sample of adding menu items
			HMENU hSubMenu = GetSubMenu(hMenu, 4);
			// Define CmdProc as "void WINAPI CmdProc(HWND, LPARAM)"
			UINT nID = bka.RegisterCommand("Information about this Command", nType,CmdProc);
			AppendMenu(hSubMenu, MF_STRING, nID, "&Menu item");
			*/
			/* If needed, you can register the command UI update callback.
			// Define CmdUIProc as "UINT WINAPI CmdUIProc(HWND, LPARAM)"
			bka.RegisterUICallback(nID, CmdUIProc);
			*/
		}
		break;
	case BKC_MENU_LISTVIEW:
		{
			int menuPos = -1;
			switch (g_ctxMenuProfile.GetMenuPosition()) {
			case ContextMenuProfile::ContextMenuTop:
				menuPos = 0;
				break;
			case ContextMenuProfile::ContextMenuBottom:
				menuPos = -1;
				break;
			case ContextMenuProfile::ContextMenuPos:
				menuPos = g_ctxMenuProfile.GetMenuPos();
				break;
			}

			if (g_ctxMenuProfile.GetUpperSeparator()) {
				InsertMenu(hMenu, menuPos, MF_BYPOSITION | MF_SEPARATOR, 0, 0);
				if (0 <= menuPos) {
					++menuPos;
				}
			}

			std::string menuTitle = CResourceManager::FormatResourceString(IDS_CTXMENU_TITLE);

			//
			// Tuj[ǉ
			//

			// e
			HMENU hMenuBsfilWrap = CreateMenu();
			InsertMenu(hMenu, menuPos, MF_BYPOSITION | MF_POPUP | MF_STRING, (UINT) hMenuBsfilWrap, menuTitle.c_str());
			if (0 <= menuPos) {
				++menuPos;
			}

			// q
			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_EMAIL_SPAM_ACTION, Menu_CmdProc_ToSpam, Menu_CmdUIProc);
			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_EMAIL_JUDGE_AND_ACTION, Menu_CmdProc_TestMailAndFilter, Menu_CmdUIProc);

			InsertMenu(hMenuBsfilWrap, -1, MF_BYPOSITION | MF_SEPARATOR, 0, 0);
			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_EMAIL_JUDGE_TEST, Menu_CmdProc_TestMail, Menu_CmdUIProc);

			InsertMenu(hMenuBsfilWrap, -1, MF_BYPOSITION | MF_SEPARATOR, 0, 0);

			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_ADD_SPAM_AND_DBUPDATE, Menu_CmdProc_AddSpam, Menu_CmdUIProc);
			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_ADD_CLEAN_AND_DBUPDATE, Menu_CmdProc_AddClean, Menu_CmdUIProc);

			InsertMenu(hMenuBsfilWrap, -1, MF_BYPOSITION | MF_SEPARATOR, 0, 0);

			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_SUB_SPAM_AND_DBUPDATE, Menu_CmdProc_SubSpam, Menu_CmdUIProc);
			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_SUB_CLEAN_AND_DBUPDATE, Menu_CmdProc_SubClean, Menu_CmdUIProc);

			InsertMenu(hMenuBsfilWrap, -1, MF_BYPOSITION | MF_SEPARATOR, 0, 0);

			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_DBUPDATE, Menu_CmdProc_Update, 0);
			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_SHOW_DB_STATUS, Menu_CmdProc_ShowDbStatus, 0);

			InsertMenu(hMenuBsfilWrap, -1, MF_BYPOSITION | MF_SEPARATOR, 0, 0);

			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_REMOVE_EMAIL_SPAM_HEADER, Menu_CmdProc_RemoveSpamHeader, Menu_CmdUIProc);

			InsertMenu(hMenuBsfilWrap, -1, MF_BYPOSITION | MF_SEPARATOR, 0, 0);

			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_ADD_SENDER_TO_WHITELIST, Menu_CmdProc_AddToWhiteList, Menu_CmdUIProc);
			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_ADD_SENDER_DOMAIN_TO_WHITELIST, Menu_CmdProc_AddDomainToWhiteList, Menu_CmdUIProc);

			InsertMenu(hMenuBsfilWrap, -1, MF_BYPOSITION | MF_SEPARATOR, 0, 0);

			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_REMOVE_SENDER_FROM_WHITELIST, Menu_CmdProc_RemoveFromWhiteList, Menu_CmdUIProc);
			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_REMOVE_SENDER_DOMAIN_FROM_WHITELIST, Menu_CmdProc_RemoveDomainFromWhiteList, Menu_CmdUIProc);

			InsertMenu(hMenuBsfilWrap, -1, MF_BYPOSITION | MF_SEPARATOR, 0, 0);

			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_ADD_FROMNAME_TO_NG_WORD_LIST, Menu_CmdProc_AddFromnameToNgWordList, Menu_CmdUIProc);
			AppendBkBsfilMenu(hMenuBsfilWrap, -1, nType, IDS_CTXMENU_ADD_ADD_SUBJECT_TO_NG_WORD_LIST, Menu_CmdProc_AddSubjectToNgWordList, Menu_CmdUIProc);

			if (g_ctxMenuProfile.GetLowerSeparator()) {
				InsertMenu(hMenu, menuPos, MF_BYPOSITION | MF_SEPARATOR, 0, 0);
				if (0 <= menuPos) {
					++menuPos;
				}
			}
		}
		break;
	case BKC_MENU_TREEVIEW:
		break;
	case BKC_MENU_MSGVIEW:
		break;
	case BKC_MENU_MSGEDIT:
		break;
	case BKC_MENU_TASKTRAY:
		break;
	case BKC_MENU_COMPOSE:
		break;
	case BKC_MENU_COMPEDIT:
		break;
	case BKC_MENU_COMPREF:
		break;
	default:
		break;
	}
	// Always return 0.
	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a folder is opened.
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnOpenFolder(LPCTSTR lpFolderID)
{
	// Always return 0.
	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a mail is selected.
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnOpenMail(LPCTSTR lpMailID)
{
	// Always return 0.
	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called every minute.
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnEveryMinute()
{
	// Always return 0.
	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a compose windows is opened.
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnOpenCompose(HWND hWnd, int nMode/* See COMPOSE_MODE_* in BeckyApi.h */)
{
	// Always return 0.
	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when the composing message is saved.
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnOutgoing(HWND hWnd, int nMode/* 0:SaveToOutbox, 1:SaveToDraft, 2:SaveToReminder*/)
{
	// Return -1 if you do not want to send it yet.
	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a key is pressed.
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnKeyDispatch(HWND hWnd, int nKey/* virtual key code */, int nShift/* Shift state. 0x40=Shift, 0x20=Ctrl, 0x60=Shift+Ctrl, 0xfe=Alt*/)
{
	// Return TRUE if you want to suppress subsequent command associated to this key.
	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a message is retrieved and saved to a folder
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnRetrieve(LPCTSTR lpMessage/* Message source*/, LPCTSTR lpMailID/* Mail ID*/)
{
	// Always return 0.
	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a message is spooled
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnSend(LPCTSTR lpMessage/* Message source */)
{
#define __FUNCNAME__ "BKC_OnSend()"
	// Return BKC_ONSEND_PROCESSED, if you have processed this message
	// and don't need Becky! to send it.
	// Becky! will move this message to Sent box when the sending
	// operation is done.
	// CAUTION: You are responsible for the destination of this
	// message if you return BKC_ONSEND_PROCESSED.

	// Return BKC_ONSEND_ERROR, if you want to cancel the sending operation.
	// You are responsible for displaying an error message.

	// Return 0 to proceed the sending operation.

	if (lpMessage == 0) {
		LOGGING_WARN("lpMessage == 0.");
		return 0;
	}

	if (g_bkProfile.GetAddToAddrToWhiteListOnSend()) {

		//
		// MɑMzCgXgɒǉ
		//

		// M(g)̃[AhX𓾂
		std::string fromEmail;
		std::string from = Util::GetHeaderFieldBody(lpMessage, "From");
		{
			char name[1024] = "";
			char email[512] = "";

			GetDecodedNameAndAddr(name, sizeof(name), email, sizeof(email), from.c_str());
			if (strlen(email) != 0) {
				fromEmail = email;
			}
		}

		// M悩烁[AhẌꗗ𓾂
		std::map<std::string, std::string> addrList;

		std::string to = Util::GetHeaderFieldBody(lpMessage, "To");
		AddSenderAddrToList(&addrList, to);
		std::string cc = Util::GetHeaderFieldBody(lpMessage, "Cc");
		AddSenderAddrToList(&addrList, cc);
		std::string bcc = Util::GetHeaderFieldBody(lpMessage, "Bcc");
		AddSenderAddrToList(&addrList, bcc);


		//
		// zCgXgɒǉ
		//
		{
			CSLock cslock(&g_csSetting);

			bool bSaveToWhiteListFile = false;

			for (std::map<std::string, std::string>::iterator it = addrList.begin(); it != addrList.end(); ++it) {

				if (g_myMailList.IsExist(it->first.c_str())) {
					// g̃[AhX͓o^Ȃ
					LOGGING_INFO("in my email list: email: [%s].", it->first.c_str());
					continue;
				}

				if (strcmp(fromEmail.c_str(), it->first.c_str()) == 0) {
					// M(g)ƑM悪ꍇ͓o^Ȃ
					// NOTE: zCgXgɎg̃AhXo^Ȃ߁Â悤ȂƂĂB
					//       Ag̕ʂ̃[AhXɑ΂đꍇ邽߁ACx߂ɉ߂ȂB
					//       g̃[AhX͑OiŃ`FbNĂ͂邪A
					//       VKɒǉ[{bNX͂ɂ͔fȂ悤Ȃ̂ŁÃR[hcĂB
					//       Becky! gpĂ郁[{bNX̃A^Cȃ[AhXꗗƊ̂A
					//       _ł͕@킩ȂB
					LOGGING_INFO("in from: email: [%s].", it->first.c_str());
					continue;
				}

				bool bNoteIsEmpty = false;
				if (g_whileSetting) {
					// ݒ_CAO\͂ɓo^
					if (g_whiteListSub.IsNotExistOrNoteIsEmpty(it->first.c_str(), &bNoteIsEmpty)) {
						std::string note = Util::Trim(it->second);
						if (!bNoteIsEmpty || (bNoteIsEmpty && 0 < note.length())) {
							// ݂ȂAo^ς݂̔lŁAAo^悤ƂAhX̔lłȂꍇ̂
							g_whiteListSub.AddOrUpdate(it->first.c_str(), note.c_str());
						}
					}
				} else {
					if (g_whiteList.IsNotExistOrNoteIsEmpty(it->first.c_str(), &bNoteIsEmpty)) {
						std::string note = Util::Trim(it->second);
						if (!bNoteIsEmpty || (bNoteIsEmpty && 0 < note.length())) {
							g_whiteList.AddOrUpdate(it->first.c_str(), it->second.c_str());
							LOGGING_INFO("add or update white list: [%s].", it->first.c_str());
							bSaveToWhiteListFile = true;
						}
					}
				}
			}

			if (!g_whileSetting && bSaveToWhiteListFile) {
				// ݒ_CAO\ĂȂȂAzCgXgt@Cɕۑ
				g_whiteList.Export(g_whiteListFilepath);
			}
		}
	}

	return 0;

#undef __FUNCNAME__
}

////////////////////////////////////////////////////////////////////////
// Called when all messages are retrieved
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnFinishRetrieve(int nNumber/* Number of messages*/)
{
	// Always return 0.
	return 0;
}


////////////////////////////////////////////////////////////////////////
// Called when plug-in setup is needed.
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnPlugInSetup(HWND hWnd)
{
#define __FUNCNAME__ "BKC_OnPlugInSetup()"
	// Return nonzero if you have processed.
	// return 1;

	SettingDialogParam settingDlgParam;

	{
		CSLock cslock(&g_csSetting);

		g_whileSetting = true;

		settingDlgParam.pbka = &bka;
		settingDlgParam.bkaDataFolder = g_bkaDataFolder;
		settingDlgParam.dataFolder = g_dataFolder;
		settingDlgParam.bsfilterConfig = g_bsfilterConfig;
		settingDlgParam.dbFolder = g_dbFolder;
		settingDlgParam.bkProfile = g_bkProfile;
		settingDlgParam.ctxMenuProfile = g_ctxMenuProfile;
		settingDlgParam.execBsScriptProfile = g_execBsScriptProfile;
		
		settingDlgParam.bkWhiteListProfileEnv = g_bkWhiteListProfileEnv;
		settingDlgParam.whiteList = g_whiteList;

		settingDlgParam.ngWordProfile = g_ngWordProfile;
		settingDlgParam.ngWordProfileEnv = g_ngWordProfileEnv;
		settingDlgParam.ngWordList = g_ngWordList;

		settingDlgParam.pcsDatabase = &g_csDatabase;

		// rp̐ݒ
		settingDlgParam.bkProfile.SetLockObject(0);
		settingDlgParam.ctxMenuProfile.SetLockObject(0);
		settingDlgParam.ngWordProfile.SetLockObject(0);

		settingDlgParam.whiteList.SetLockObject(0);
		settingDlgParam.ngWordList.SetLockObject(0);

		settingDlgParam.bkWhiteListProfileEnv.SetLockObject(0);
		settingDlgParam.ngWordProfileEnv.SetLockObject(0);


		// \[gĂ
		settingDlgParam.whiteList.SetSortKey(settingDlgParam.bkWhiteListProfileEnv.GetSortKey());
		settingDlgParam.whiteList.SetAscending(settingDlgParam.bkWhiteListProfileEnv.IsAscending());
		settingDlgParam.whiteList.Sort();

		settingDlgParam.ngWordList.SetSortKey(settingDlgParam.ngWordProfileEnv.GetSortKey());
		settingDlgParam.ngWordList.SetAscending(settingDlgParam.ngWordProfileEnv.IsAscending());
		settingDlgParam.ngWordList.Sort();
	}

	CSettingDialog settingDlg(settingDlgParam);
	int rc = settingDlg.DoModal(hWnd);

	//
	// ۑ
	//

	{
		CSLock cslock(&g_csSetting);

		bool bSaveProfile = false;
		bool bSaveToWhiteListFile = false;
		bool bSaveToNgWordListFile = false;

		if (0 < rc) {
			// _CAOŁuOKvNbNꂽꍇ͕Kt@Cɕۑ
			bSaveProfile = true;
			bSaveToWhiteListFile = true;
			bSaveToNgWordListFile = true;

			// rp̐ݒǉ
			settingDlgParam.bkProfile.SetLockObject(&g_csSetting);
			settingDlgParam.ctxMenuProfile.SetLockObject(&g_csSetting);
			settingDlgParam.ngWordProfile.SetLockObject(&g_csSetting);

			settingDlgParam.whiteList.SetLockObject(&g_csSetting);
			settingDlgParam.ngWordList.SetLockObject(&g_csSetting);

			// ł͊̐ݒɂ͔rp̐ݒǉȂ
			////settingDlgParam.bkWhiteListProfileEnv.SetLockObject(0);
			////settingDlgParam.ngWordProfileEnv.SetLockObject(0);

			g_bkProfile = settingDlgParam.bkProfile;
			g_ctxMenuProfile = settingDlgParam.ctxMenuProfile;
			g_execBsScriptProfile = settingDlgParam.execBsScriptProfile;
			g_ngWordProfile = settingDlgParam.ngWordProfile;
			g_whiteList = settingDlgParam.whiteList;
			g_ngWordList = settingDlgParam.ngWordList;
		}

		// ̐ݒ͏ɕۑ
		settingDlgParam.bkWhiteListProfileEnv.SetLockObject(&g_csSetting);
		g_bkWhiteListProfileEnv = settingDlgParam.bkWhiteListProfileEnv;

		settingDlgParam.ngWordProfileEnv.SetLockObject(&g_csSetting);
		g_ngWordProfileEnv = settingDlgParam.ngWordProfileEnv;


		// ݒ_CAO\ɁAMɃzCgXg֒ǉꂽ̂΁AŒǉ
		std::map<std::string, MailAddressInfo>& whiteMailListSub = g_whiteListSub.GetMailAddressList();
		for (std::map<std::string, MailAddressInfo>::iterator it = whiteMailListSub.begin(); it != whiteMailListSub.end(); ++it) {

			bool bNoteIsEmpty = false;
			if (g_whiteList.IsNotExistOrNoteIsEmpty(it->second.GetMailAddress().c_str(), &bNoteIsEmpty)) {
				std::string note = Util::Trim(it->second.GetNote());
				if (!bNoteIsEmpty || (bNoteIsEmpty && 0 < note.length())) {
					// ݂ȂAo^ς݂̔lŁAAo^悤ƂAhX̔lłȂꍇ̂
					g_whiteList.AddOrUpdate(it->second.GetMailAddress().c_str(), note.c_str());
					LOGGING_INFO("add or update white list: [%s].", it->second.GetMailAddress().c_str());
					// ǉ΁At@Cɕۑ
					bSaveToWhiteListFile = true;
				}
			}
		}
		g_whiteListSub.ClearAll();

		g_whileSetting = false;

		if (bSaveProfile) {
			// ݒt@Cɕۑ
			g_profileManager.Save(g_bkBsfilProfileList);
		}

		if (bSaveToWhiteListFile) {
			// zCgXgt@Cɕۑ
			g_whiteList.Export(g_whiteListFilepath);
		}

		if (bSaveToNgWordListFile) {
			// NG [hꗗt@Cɕۑ
			g_ngWordList.Export(g_ngWordListFilepath);
		}

		// ̐ݒ͏ɕۑ
		g_profileManagerEnv.Save(g_bkBsfilProfileEnvList);
	}

	return 1;

#undef __FUNCNAME__
}

////////////////////////////////////////////////////////////////////////
// Called when plug-in information is being retrieved.
////////////////////////////////////////////////////////////////////////

typedef struct tagBKPLUGININFO
{
	char szPlugInName[80]; // Name of the plug-in
	char szVendor[80]; // Name of the vendor
	char szVersion[80]; // Version string
	char szDescription[256]; // Short description about this plugin
} BKPLUGININFO, *LPBKPLUGININFO;

int WINAPI BKC_OnPlugInInfo(LPBKPLUGININFO lpPlugInInfo)
{
	CFileVersionInfo fvi(g_hInstance);

	std::string productName = fvi.GetProductName();
	std::string companyName = fvi.GetCompanyName();
	std::string productVersion = fvi.GetProductVersion();
	std::string comments = fvi.GetComments();

	strncpy(lpPlugInInfo->szPlugInName, productName.c_str(), sizeof(lpPlugInInfo->szPlugInName));
	FORCE_ASCIZ(lpPlugInInfo->szPlugInName);

	strncpy(lpPlugInInfo->szVendor, companyName.c_str(), sizeof(lpPlugInInfo->szVendor));
	FORCE_ASCIZ(lpPlugInInfo->szVendor);

	strncpy(lpPlugInInfo->szVersion, productVersion.c_str(), sizeof(lpPlugInInfo->szVersion));
	FORCE_ASCIZ(lpPlugInInfo->szVersion);

	strncpy(lpPlugInInfo->szDescription, comments.c_str(), sizeof(lpPlugInInfo->szDescription));
	FORCE_ASCIZ(lpPlugInInfo->szDescription);

	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when drag and drop operation occurs.
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnDragDrop(LPCSTR lpTgt, LPCSTR lpSrc, int nCount, int dropEffect)
{
	/*
	lpTgt:	A folder ID of the target folder.
			You can assume it is a root mailbox, if the string
			contains only one '\' character.
	lpSrc:	Either a folder ID or mail IDs. Multiple mail IDs are
			separated by '\n' (0x0a).
			You can assume it is a folder ID, if the string
			doesn't contain '?' character.
	nCount:	Number of items to be dropped.
			It can be more than one, if you drop mail items.
	dropEffect: Type of drag and drop operation
			1: Copy
			2: Move
			4: Link (Used for filtering setup in Becky!)
	*/
	// If you want to cancel the default drag and drop action,
	// return -1;
	// Do not assume the default action (copy, move, etc.) is always
	// processed, because other plug-ins might cancel the operation.
	return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a message was retrieved and about to be filtered.
////////////////////////////////////////////////////////////////////////

int WINAPI BKC_OnBeforeFilter2(LPCSTR lpMessage, LPCSTR lpMailBox, int* lpnAction, char** lppParam)
{
#define __FUNCNAME__ "BKC_OnBeforeFilter2()"
	/*
    lpMessage: A complete message source, which ends with
    "<CRLF>.<CRLF>".
    lpnAction:	[out] Returns the filtering action to be applied.
    	#define ACTION_NOTHING		-1	// Do nothing
		#define ACTION_MOVEFOLDER	0	// Move to a folder
		#define ACTION_COLORLABEL	1	// Set the color label
		#define ACTION_SETFLAG		2	// Set the flag
		#define ACTION_SOUND		3	// Make a sound
		#define ACTION_RUNEXE		4	// Run executable file
		#define ACTION_REPLY		5	// Reply to the message
		#define ACTION_FORWARD		6	// Forward the message
		#define ACTION_LEAVESERVER	7	// Leave/delete on the server.
		#define ACTION_ADDHEADER	8	// Add "X-" header to the top of the message. (Plug-in only feature)
	lpMailBox: ID of the mailbox that is retrieving the message. (XXXXXXXX.mb\)
	lppParam:	[out] Returns the pointer to the filtering parameter string.
		ACTION_MOVEFOLDER:	Folder name.
							e.g. XXXXXXXX.mb\FolderName\
							or \FolderName\ (begin with '\') to use
							the mailbox the message belongs.
		ACTION_COLORLABEL:	Color code(BGR) in hexadecimal. e.g. 0088FF
		ACTION_SETFLAG:		"F" to set flag. "R" to set read.
		ACTION_SOUND:		Name of the sound file.
		ACTION_RUNEXE:		Command line to execute. %1 will be replaced with the path to the file that contains the entire message.
		ACTION_REPLY:		Path to the template file without extension.
								e.g. #Reply\MyReply
		ACTION_FORWARD:		Path to the template file without extension. + "*" + Address to forward.
								e.g. #Forward\MyForward*mail@address
									 *mail@address (no template)
		ACTION_LEAVESERVER:	The string consists of one or two decimals. The second decimal is optional.
							Two decimals must be separated with a space.
							First decimal	1: Delete the message from the server.
											0: Leave the message on the server.
							Second decimal	1: Do not store the message to the folder.
											0: Store the message to the folder. (default action)
							e.g. 0 (Leave the message on the server.)
								 1 1 (Delete the message on the server and do not save. (Means KILL))
		ACTION_ADDHEADER	"X-Header:data" that will be added at the top of the incoming message.
							You can specify multiple headers by separating CRLF, but each header must
							begin with "X-". e.g. "X-Plugindata1: test\r\nX-Plugindata2: test2";
	*/

	/* Return values
	BKC_FILTER_DEFAULT	Do nothing and apply default filtering rules.
	BKC_FILTER_PASS		Apply default filtering rules after applying the rule it returns.
	BKC_FILTER_DONE		Do not apply default rules.
	BKC_FILTER_NEXT		Request Becky! to call this callback again so that another rules can be added.
	*/

	// NOTE: Ô *lppParam ɃS~܂͉ς݃|C^Ă\lAݒ̂ݍsAQƂȂƁB

	int result = BKC_FILTER_DEFAULT;

	if (lpnAction == 0) {
		LOGGING_WARN("lpnAction == 0.");
		return result;
	}

	if (lppParam == 0) {
		LOGGING_WARN("lppParam == 0.");
		return result;
	}

	if (!Util::IsBsfilterInstalled(g_execBsScriptProfile, g_bsfilter, g_iconv, g_bsfilterScript)) {
		LOGGING_WARN("bsfilter Unavailable.");
		return result;
	}

	LOGGING_DEBUG("before: g_action: [%d], *lpnAction: [%d].", g_action, *lpnAction);

	*lpnAction = ACTION_NOTHING;

	if (g_action == FilterFirstStep) {

		int length = 0;
		const char* pMailEnd = strstr(lpMessage, "\r\n.\r\n");
		if (pMailEnd) {
			length = pMailEnd - lpMessage;
		} else {
			length = strlen(lpMessage);
		}

		std::string messageId = GetDecodedHeaderFieldBody(lpMessage, "Message-Id");
		std::string from = Util::GetHeaderFieldBody(lpMessage, "From");
		std::string decodedFrom = GetDecodedString(from);
		std::string to = GetDecodedHeaderFieldBody(lpMessage, "To");
		std::string subject = GetDecodedHeaderFieldBody(lpMessage, "Subject");

		Util::Replace(messageId, "\r\n", "");
		Util::Replace(decodedFrom, "\r\n", "");
		Util::Replace(to, "\r\n", "");
		Util::Replace(subject, "\r\n", "");

		//
		// zCgXgƏƂ炵킹
		//

		char fromname[4096] = "";
		{
			char email[512] = "";

			GetDecodedNameAndAddr(fromname, sizeof(fromname), email, sizeof(email), from.c_str());
			if (strlen(email) != 0 && g_whiteList.IsExistEmailOrDomain(email)) {
				LOGGING_INFO("in white list (email or domain): email: [%s], From: [%s].", email, decodedFrom.c_str());

				return result;
			}
		}

		//
		// [𔻒肷
		//

		std::string output;
		int rc = ExecBsfilter(lpMessage, length, &output, "");

		LOGGING_INFO("ExecBsfilter(): rc: [%d], Message-Id: [%s], From: [%s], To: [%s], Subject: [%s].", rc, messageId.c_str(), decodedFrom.c_str(), to.c_str(), subject.c_str());

		if (rc != 0) {
			//
			// spam Ɣ肳Ȃꍇ
			//
			if (g_ngWordProfile.GetUseNgWord()) {
				// NG [hgpꍇ
				if (g_ngWordList.IsMatch(subject.c_str(), fromname)) {
					rc = 0;	// spam Ƃ
					LOGGING_INFO("g_ngWordList: match.");
				}
			}
		}


		if (rc == 0) {

			if (g_bkProfile.GetSetReadToSpamMail()) {
				//
				// spam Ɣ肳ꂽ[͊ǂɂ
				//
				const char* readFlag = "R";

				char* rcReadFlg = (char*) bka.Alloc(strlen(readFlag) + 1);
				strcpy(rcReadFlg, readFlag);

				*lpnAction = ACTION_SETFLAG;
				*lppParam = rcReadFlg;

				// x̊֐Ăł炤
				g_action = FilterSecondStep;
				result = BKC_FILTER_NEXT;

			} else {
				//
				// spam Ɣ肳ꂽ[u
				//
				result = ProcessSpamMail(lpMessage, lpMailBox, lpnAction, lppParam);
			}
		}

	} else /* if (g_action == FilterSecondStep)*/ {
		//
		// spam Ɣ肳ꂽ[u
		//
		result = ProcessSpamMail(lpMessage, lpMailBox, lpnAction, lppParam);

		// tOɖ߂
		g_action = FilterFirstStep;
	}

	LOGGING_DEBUG("after: g_action: [%d], *lpnAction: [%d].", g_action, *lpnAction);

	return result;

#undef __FUNCNAME__
}

#ifdef __cplusplus
}
#endif
