#pragma once

#include <string>
#include <vector>
#include <map>
#include <set>

////////////////////////////////////////////////////////////////////////
// NG [h
////////////////////////////////////////////////////////////////////////

// NG [hɓ͂łő啶
#define NUM_NG_WORD_MAX	512

class NgWord {
public:
	// NG [h̎
	enum WordType { NgwAll = 0, NgwSubject = 1, NgwFromname = 2 };

public:
	// RXgN^
	NgWord();
	// RXgN^
	NgWord(const char* ngword, const WordType wdType, const bool bRegex, const bool bCase);

public:
	// }b`邩
	bool IsMatch(const char* subject, const char* fromname);

public:
	// NG [h
	std::string& GetWord();
	// NG [h̎
	WordType GetWordType();
	char* GetWordTypeStr();
	char* GetWordTypeJStr();
	// K\
	bool IsRegex();
	// p召
	bool IsCase();

private:
	// NG [h
	std::string m_word;
	// NG [h̎
	WordType m_wordType;
	// K\
	bool m_bRegex;
	// p召
	bool m_bCase;
};

////////////////////////////////////////////////////////////////////////
// NG [hꗗ
////////////////////////////////////////////////////////////////////////

class NgWordList {
public:
	// RXgN^
	NgWordList();

public:
	// NG [hɃ}b`̂邩𓾂
	bool IsMatch(const char* subject, const char* fromname);
	// NG [h݂邩𓾂
	bool IsExist(const char* ngword);
	// NG [h̏𓾂
	std::map<std::string, NgWord>& GetNgWordList();
	// NG [ȟ𓾂
	int Count();
	// NG [hǉ
	void Add(const char* ngword, const NgWord::WordType wdType, const bool bRegex, const bool bCase);
	// 폜
	void Delete(const char* ngword);
	// XV
	void Update(const char* ngword, const NgWord::WordType wdType, const bool bRegex, const bool bCase);
	// ǉ܂͍XV
	void AddOrUpdate(const char* ngword, const NgWord::WordType wdType, const bool bRegex, const bool bCase);
	// SNA
	void ClearAll();
	// C|[g
	void Import(const char* filepath);
	// GNX|[g
	void Export(const char* filepath);

public:
	// rp̃IuWFNgݒ肷
	void SetLockObject(CRITICAL_SECTION* pcsNgWordList);

private:
	// rp
	CRITICAL_SECTION* m_pcsNgWordList;

private:
	// NG [ḧꗗ
	std::map<std::string, NgWord> m_ngWordList;

//
// \[ĝ߂̎
//
public:
	// \[g鍀
	enum SortKey { SortNgwType = 0, SortNgwWord = 1, SortNgwRegex = 2, SortNgwCase = 3 };

public:
	// \[gs
	void Sort();
	// \[gL[擾/ݒ
	SortKey GetSortKey();
	void SetSortKey(SortKey sortKey);
	// ǂ擾/ݒ
	bool IsAscending();
	void SetAscending(bool bAscending);
	// n Ԗڂ NG [hԂ
	NgWord& GetAt(int index);
	// w NG [h̃CfbNXԂ
	int GetIndex(const char* ngword);
	// n Ԗڂ NG [h폜
	bool DeleteAt(int index);

private:
	// \[gL[
	SortKey m_sortKey;
	// ǂ
	bool m_bAscending;
	// \[g̃L[ێ
	std::vector<std::string> m_sortedNgWord;
	// ftHgp̒l(ʏ͎gpȂ)
	NgWord m_emptyNgw;
};

